#
# Calamari Spec File
#

%if ! (0%{?fedora} > 12 || 0%{?rhel} > 5)
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%define debug_package %{nil}

%{!?_selinux_policy_version: %global _selinux_policy_version %(sed -e 's,.*selinux-policy-\\([^/]*\\)/.*,\\1,' /usr/share/selinux/devel/policyhelp 2>/dev/null)}
%global selinux_variants targeted

#################################################################################
# common
#################################################################################
Name:		calamari-server
Summary:	Manage and monitor Ceph with a REST API
Group:		System/Filesystems
# We need this for apache user
BuildRequires:	httpd
BuildRequires:	postgresql-devel
BuildRequires:	python-setuptools
BuildRequires:	python-virtualenv
BuildRequires:	redhat-lsb-core
Requires:	httpd
Requires:	mod_wsgi
Requires:	cairo
Requires:	pycairo
Requires:	logrotate
Requires:	supervisor
Requires:	salt-master
Requires:	salt-minion
Requires:	redhat-lsb-core
Requires:	postgresql
Requires:	postgresql-libs
Requires:	postgresql-server
Requires:	python-setuptools
%if 0%{?rhel} || 0%{?fedora}
# SELinux deps
BuildRequires:  checkpolicy
BuildRequires:  selinux-policy-devel
BuildRequires:  /usr/share/selinux/devel/policyhelp
BuildRequires:  hardlink
Requires:       policycoreutils, libselinux-utils
Requires(post): selinux-policy >= %{_selinux_policy_version}, policycoreutils
Requires(postun): policycoreutils
%endif
Version: 	1.3.3
Release: 	2%{?dist}
License: 	LGPL-2.1+
URL:		http://ceph.com/
Source0: 	%{name}_%{version}.tar.gz
Source1:	alembic-0.6.3.tar.gz
Provides:	bundled(python-alembic) = 0.6.3
Source2:	argparse-1.2.1.tar.gz
Provides:	bundled(python-argparse) = 1.2.1
Source3:	carbon-0.9.13.tar.gz
Provides:	bundled(carbon) = 0.9.13
Source4:	ceph-graphite-web-0.9.11-57-g6f23d36.tar.gz
Provides:	bundled(python-graphite-web) = 0.9.11
Source5:	Cython-0.19.2.tar.gz
Provides:	bundled(Cython) = 0.19.2
Source6:	Django-1.5.1.tar.gz
Provides:	bundled(Django) = 1.5.1
Source7:	django-filter-0.6.tar.gz
Provides:	bundled(python-django-filter) = 0.6
Source8:	djangorestframework-2.3.12.tar.gz
Provides:	bundled(python-djangorestframework) = 2.3.12
Source9:	django-tagging-0.3.1.tar.gz
Provides:	bundled(django-tagging) = 0.3.1
Source10:	gevent-1.0.1.tar.gz
Provides:	bundled(python-gevent) = 1.0.1
Source11:	graphite-project-whisper-0.9.11-pre1-56-ga6e2176.tar.gz
Provides:	bundled(graphite-project-whisper) = 0.9.10
Source12:	greenlet-0.4.5.zip
Provides:	bundled(python-greenlet) = 0.4.5
Source13:	Mako-1.0.0.tar.gz
Provides:	bundled(python-mako) = 1.0.0
Source14:	manhole-0.6.0.tar.gz
Provides:	bundled(python-manhole) = 0.6.0
Source15:	MarkupSafe-0.23.tar.gz
Provides:	bundled(python-markupsafe) = 0.23
Source16:	msgpack-python-0.4.4.tar.gz
Provides:	bundled(python-msgpack) = 0.4.4
Source17:	psycogreen-1.0.tar.gz
Provides:	bundled(psycogreen) = 1.0
Source18:	psycopg2-2.5.2.tar.gz
Provides:	bundled(psycopg2) = 2.5.2
Source19:	python-dateutil-2.2.tar.gz
Provides:	bundled(dateutil) = 2.2
Source20:	pytz-2013.8.tar.bz2
Provides:	bundled(pytz) = 2013.8
Source21:	pyzmq-14.2.0.tar.gz
Provides:	bundled(pyzmq) = 14.2.0
Source22:	setuptools-12.0.4-py2.py3-none-any-stripped.whl
Source23:	setuptools-12.0.4-stripped.tar.gz
Provides:	bundled(python-setuptools) = 12.0.4
Source24:	six-1.9.0.tar.gz
Provides:	bundled(python-six) = 1.9.0
Source25:	SQLAlchemy-0.8.3.tar.gz
Provides:	bundled(python-sqlalchemy) = 0.8.3
Source26:	Twisted-11.1.0.tar.bz2
Provides:	bundled(python-twisted) = 11.1.0
Source27:	Twisted-14.0.2.tar.bz2
Provides:	bundled(python-twisted) = 14.0.2
Source28:	txAMQP-0.6.2.tar.gz
Provides:	bundled(python-txamqp) = 0.6.2
Source29:	wsgiref-0.1.2.zip
Provides:	bundled(python-wsgiref) = 0.1.2
Source30:	zerorpc-0.4.4.tar.gz
Provides:	bundled(python-zerorpc) = 0.4.4
Provides:	bundled(python-zope-interface) = 4.1.2
Source31:	zope.interface-4.1.2.tar.gz

Patch0001: 0001-RHEL-7-compile-patch.patch
Patch0002: 0002-Do-not-assert-0-for-osd-metadata-command.patch

%prep
%setup -T -b 0 -q -n %{name}-%{version}

%patch0001 -p1
%patch0002 -p1

mkdir -p pkgs
cp -p %SOURCE1 pkgs/
cp -p %SOURCE2 pkgs/
cp -p %SOURCE3 pkgs/
cp -p %SOURCE4 pkgs/
cp -p %SOURCE5 pkgs/
cp -p %SOURCE6 pkgs/
cp -p %SOURCE7 pkgs/
cp -p %SOURCE8 pkgs/
cp -p %SOURCE9 pkgs/
cp -p %SOURCE10 pkgs/
cp -p %SOURCE11 pkgs/
cp -p %SOURCE12 pkgs/
cp -p %SOURCE13 pkgs/
cp -p %SOURCE14 pkgs/
cp -p %SOURCE15 pkgs/
cp -p %SOURCE16 pkgs/
cp -p %SOURCE17 pkgs/
cp -p %SOURCE18 pkgs/
cp -p %SOURCE19 pkgs/
cp -p %SOURCE20 pkgs/
cp -p %SOURCE21 pkgs/
cp -p %SOURCE22 pkgs/setuptools-12.0.4-py2.py3-none-any.whl
cp -p %SOURCE23 pkgs/setuptools-12.0.4.tar.gz
cp -p %SOURCE24 pkgs/
cp -p %SOURCE25 pkgs/
cp -p %SOURCE26 pkgs/
cp -p %SOURCE27 pkgs/
cp -p %SOURCE28 pkgs/
cp -p %SOURCE29 pkgs/
cp -p %SOURCE30 pkgs/
cp -p %SOURCE31 pkgs/

%build
%if 0%{?fedora} || 0%{?rhel}
cd selinux
for selinuxvariant in %{selinux_variants}
do
make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile
mv calamari-server.pp calamari-server.pp.${selinuxvariant}
make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile clean
done
cd -
%endif

%install
make VERSION=%{version} REVISION=0 DESTDIR=${RPM_BUILD_ROOT} install-rpm
chmod -R go-w ${RPM_BUILD_ROOT}/opt/calamari/venv/lib/python2.7/site-packages/setuptools-0.9.8-py2.7.egg-info
find ${RPM_BUILD_ROOT} -name '*.so' -exec eu-strip {} \;
%if 0%{?fedora} || 0%{?rhel}
# Install SELinux policy
for selinuxvariant in %{selinux_variants}
do
	install -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
	install -p -m 644 selinux/calamari-server.pp.${selinuxvariant} \
		%{buildroot}%{_datadir}/selinux/${selinuxvariant}/calamari-server.pp
	# We package everything that remains in selinux dir as doc
	# Remove the binary files so as not to package them as doc
	rm -f selinux/calamari-server.pp.${selinuxvariant}
done
/usr/sbin/hardlink -cv %{buildroot}%{_datadir}/selinux
%endif

%description -n calamari-server
Calamari is a webapp to monitor and control a Ceph cluster via a web
browser. 

%files -n calamari-server
/opt/calamari/alembic
/opt/calamari/conf
/opt/calamari/salt
/opt/calamari/salt-local
/opt/calamari/venv
%attr (-, apache, apache) /opt/calamari/webapp/calamari
%{_sysconfdir}/salt/master.d/calamari.conf
%{_sysconfdir}/graphite/
%{_sysconfdir}/supervisor/conf.d/calamari.conf
%{_sysconfdir}/logrotate.d/calamari
%{_sysconfdir}/httpd/conf.d/calamari.conf
%{_sysconfdir}/calamari/
/usr/bin/calamari-ctl
%dir %attr (755, apache, apache) /var/log/calamari
%dir %attr (755, apache, apache) /var/log/graphite
%dir /var/lib/calamari
%dir /var/lib/cthulhu
%dir %attr (755, apache, apache) /var/log/calamari
%dir %attr (755, apache, apache) /var/log/graphite
%dir %attr(-, apache, apache) /var/lib/graphite
%dir %attr(-, apache, apache) /var/lib/graphite/log
%dir %attr(-, apache, apache) /var/lib/graphite/log/webapp
%dir %attr(-, apache, apache) /var/lib/graphite/whisper
%if 0%{?fedora} || 0%{?rhel}
%doc selinux/*
%{_datadir}/selinux/*/calamari-server.pp
%endif

%post -n calamari-server

%if 0%{?fedora} || 0%{?rhel}
calamari_selinux()
{
	# Set some SELinux booleans
	setsebool httpd_can_network_connect=on
	setsebool httpd_can_network_connect_db=on

	# Load the policy
	for selinuxvariant in %{selinux_variants}
	do
		/usr/sbin/semodule -s ${selinuxvariant} -i \
		%{_datadir}/selinux/${selinuxvariant}/calamari-server.pp &> /dev/null || :
	done
}

calamari_selinux
%endif

calamari_httpd()
{
	# centos64
	mv /etc/httpd/conf.d/welcome.conf /etc/httpd/conf.d/welcome.conf.orig

	# Load our salt config
	service salt-master restart

	# concatenate our config chunk with supervisord.conf
	echo "### START calamari-server ###" >> /etc/supervisord.conf
	cat /etc/supervisor/conf.d/calamari.conf >> /etc/supervisord.conf
	echo "### END calamari-server ###" >> /etc/supervisord.conf

	# Load our supervisor config
	service supervisord stop
	sleep 3
	service supervisord start
}

calamari_httpd
service httpd stop || true
service httpd start

# Prompt the user to proceed with the final script-driven
# part of the installation process
echo "Thank you for installing Calamari."
echo ""
echo "Please run 'sudo calamari-ctl initialize' to complete the installation."
exit 0

%preun -n calamari-server
if [ $1 == 0 ] ; then 
	rm /etc/httpd/conf.d/calamari.conf
	rm /etc/httpd/conf.d/wsgi.conf
	mv /etc/httpd/conf.d/welcome.conf.orig /etc/httpd/conf.d/welcome.conf
	service httpd stop || true
	service httpd start || true
	service supervisord stop
	sed -i '/^### START calamari-server/,/^### END calamari-server/d' /etc/supervisord.conf
	service supervisord start
fi
exit 0

%postun -n calamari-server
# Remove anything left behind in the calamari and graphite
# virtual environment  directories, if this is a "last-instance" call
if [ $1 == 0 ] ; then
	%if 0%{?fedora} || 0%{?rhel}
	for selinuxvariant in %{selinux_variants}
	do
		/usr/sbin/semodule -s ${selinuxvariant} -r calamari-server &> /dev/null || :
	done
	# Turn off some sebools
	setsebool httpd_can_network_connect=off
	setsebool httpd_can_network_connect_db=off
	%endif
	rm -rf /opt/graphite
	rm -rf /opt/calamari
	rm -rf /var/log/graphite
	rm -rf /var/log/calamari
	rm -rf /var/lib/graphite/whisper
fi
exit 0

%changelog
* Mon Aug 22 2016 Boris Ranto <branto@redhat.com> 1.3.3-2
- Do not assert 0 for osd metadata command

* Fri Feb 05 2016 Ken Dreyer <kdreyer@redhat.com> - 1.3.3-1
- Rebase to calamari-server v1.3.3. Fixes "HTTP 500 error, calamari cannot
  write to cthulhu.log" (rhbz#1302466) and "cthulhu crashes when osd_metadata
  is missing from the OSD_map" (rhbz#1303241)

* Thu Feb 04 2016 Boris Ranto <branto@redhat.com> - 1.3.2-3
- Do not package binary SELinux policy files as doc (rhbz#1190201)
- Define SELinux variables (rhbz#1304341)

* Tue Jan 26 2016 Ken Dreyer <kdreyer@redhat.com> - 1.3.2-2
- Do not generate an (empty) -debuginfo package

* Mon Jan 25 2016 Ken Dreyer <kdreyer@redhat.com> - 1.3.2-1
- Rebase to calamari-server v1.3.2
- Add selinux support (rhbz#1190201)

* Wed Jan 20 2016 Ken Dreyer <kdreyer@redhat.com> 1.3-12
- cthulhu: stop opening connections to 172.16.79.128 (rhbz#1254609)

* Wed Nov 04 2015 Gregory Meno <gmeno@redhat.com> 1.3-11
- rest-api: fix typo in url routing for osd/command
  (rhbz#1277393)

* Thu Aug 20 2015 Ken Dreyer <kdreyer@redhat.com> 1.3-10
- Additional patch "calamari: add path to update minions during upgrade" for
  rhbz#1223335

* Fri Aug 14 2015 Ken Dreyer <kdreyer@redhat.com> 1.3-9
- calamari-ctl: Fix "No minions matched the target" when updating minions
  (rhbz#1223335)

* Wed Aug 12 2015 Ken Dreyer <kdreyer@redhat.com> 1.3-8
- Use "sudo" in CLI instructions in %%post (rhbz#1202734)
- calamari: fix getting previous CRUSH location (rhbz#1224877)

* Thu May 14 2015 Ken Dreyer <kdreyer@redhat.com> - 1.3-7
- Fix salt state that configures and enables diamond service (rhbz#1215802)

* Thu May 14 2015 Ken Dreyer <kdreyer@redhat.com> - 1.3-6
- Drop salt workaround removal patch. The original workaround is still needed
  for salt-2014.1.5. (rhbz#1217791)

* Thu Apr 30 2015 Ken Dreyer <kdreyer@redhat.com> - 1.3-5
- salt: remove old workaround for systemd (rhbz#1215802)

* Wed Apr 29 2015 Ken Dreyer <kdreyer@redhat.com> - 1.3-4
- Remove RHEL "7.0" hardcoding (rhbz#1215850)

* Fri Apr 17 2015 Boris Ranto <branto@redhat.com> - 1.3-3
- Change owners of directories in install phase, not in post script

* Fri Apr 17 2015 Boris Ranto <branto@redhat.com> - 1.3-2
- Strip libraries in virtual env (RHBZ #1192424)

* Fri Apr 17 2015 Boris Ranto <branto@redhat.com> - 1.3-1
- Rebase to 1.3

* Tue Mar 3 2015 Boris Ranto <branto@redhat.com> - 1.2.3-11
- Strip sources of binary executables

* Wed Feb 18 2015 Boris Ranto <branto@redhat.com> - 1.2.3-10
- Skipped -9 as it was built with reverted commits
- Removed diamond from Requires

* Wed Feb 11 2015 Ken Dreyer <kdreyer@redhat.com> - 1.2.3-8
- Remove RHEL "7.0" hardcoding (RHBZ #1190766)

* Tue Feb 03 2015 Ken Dreyer <kdreyer@redhat.com> - 1.2.3-6
- Remove Inktank references
- Add virtual Provides for bundled libs

* Tue Feb 3 2015 Boris Ranto <branto@redhat.com> - 1.2.3-5
- do not package world-writable files

* Fri Jan 30 2015 Boris Ranto <branto@redhat.com> - 1.2.3-4
- update sources file to not track old version of the tarball

* Fri Jan 30 2015 Boris Ranto <branto@redhat.com> - 1.2.3-3
- use correct git-tag tarball as a base

* Thu Jan 29 2015 Boris Ranto <branto@redhat.com> - 1.2.3-2
- use tagged tarball as a base

* Wed Jan 28 2015 Boris Ranto <branto@redhat.com> - 1.2.3-1
- Initial version
